(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
	typeof define === 'function' && define.amd ? define(factory) :
	(global.focusWithin = factory());
}(this, (function () { 'use strict';

function focusWithin(document, opts) {
	var _Object = Object(opts),
	    _Object$className = _Object.className,
	    className = _Object$className === undefined ? '' : _Object$className,
	    _Object$attr = _Object.attr,
	    attr = _Object$attr === undefined ? 'focus-within' : _Object$attr;

	var lastElements = [];

	function onfocuschange() {
		var lastElement = void 0;

		while (lastElement = lastElements.pop()) {
			if (attr) {
				lastElement.removeAttribute(attr);
			}

			if (className) {
				lastElement.classList.remove(className);
			}
		}

		var activeElement = document.activeElement;

		// only add focus if it has not been added and is not the document element
		if (!/^(#document|HTML|BODY)$/.test(Object(activeElement).nodeName)) {
			while (activeElement && activeElement.nodeType === 1) {
				if (attr) {
					activeElement.setAttribute(attr, '');
				}

				if (className) {
					activeElement.classList.add(className);
				}

				lastElements.push(activeElement);

				activeElement = activeElement.parentNode;
			}
		}
	}

	function initialize() {
		document.addEventListener('focus', onfocuschange, true);
		document.addEventListener('blur', onfocuschange, true);
	}

	/**
  * Callback wrapper for check loaded state
  */
	/* eslint-disable */
	!function load() {
		if (/m/.test(document.readyState)) {
			document.removeEventListener('readystatechange', load) | initialize();
		} else {
			document.addEventListener('readystatechange', load);
		}
	}();
	/* eslint-enable */
}

return focusWithin;

})));
